// Copyright (c) 2012 Krodo
// Part of Bylins http://www.mud.ru

#ifndef OBJ_ENCHANT_HPP_INCLUDED
#define OBJ_ENCHANT_HPP_INCLUDED

#include "gameplay/affects/affect_data.h"
#include "engine/structs/flag_data.h"
#include "engine/core/sysdep.h"
#include "engine/core/conf.h"

#include <string>
#include <vector>

namespace obj_sets {
struct ench_type;
}

namespace ObjectEnchant {

enum {
	//    kEnchant
	ENCHANT_FROM_OBJ,
	//   
	ENCHANT_FROM_SET
};

//    -  
struct enchant {
	enchant();
	//       (ENCHANT_FROM_OBJ)
	enchant(ObjData *obj);
	//    
	void print(CharData *ch) const;
	//       
	std::string print_to_file() const;
	//    
	void apply_to_obj(ObjData *obj) const;

	//   
	std::string name_;
	//   
	int type_;
	//  APPLY  (affected[kMaxObjAffect])
	std::vector<obj_affected_type> affected_;
	//   (obj_flags.affects)
	FlagData affects_flags_;
	//   (obj_flags.extra_flags)
	FlagData extra_flags_;
	//    (obj_flags.no_flag)
	FlagData no_flags_;
	//   (+-)
	int weight_;
	//    (     )
	int ndice_;
	int sdice_;
};

class Enchants {
 public:
	bool empty() const;
	std::string print_to_file() const;
	void print(CharData *ch) const;
	bool check(int type) const;
	void add(const enchant &ench);
	//     ( ,   ), 
	//   , ..  ,    
	void update_set_bonus(ObjData *obj, const obj_sets::ench_type &ench);
	void remove_set_bonus(ObjData *obj);

 private:
	std::vector<enchant> list_;
};

} // obj

#endif // OBJ_ENCHANT_HPP_INCLUDED

// vim: ts=4 sw=4 tw=0 noet syntax=cpp :
